A=[-2 -2 0 0; 1 0 0 0;0 0 -2 -2; 0 0 1 0];
B=[1 0 0 0;0 0 1 0]';
C=[-0.01 -10 5 0; 0 20 0.01 20];
Plant=ss(A,B,C,zeros(2,2));

omega=logspace(-3,9,150);
RGA=zeros(3,length(omega));

for i=1:length(omega)
    G=evalfr(Plant,omega(i));
    RG=G.*inv(G).';
    RGA(1,i)=RG(1,1); %diagonal RGA
    RGA(2,i)=RG(1,2); %off-diagonal RGA
    RGA(3,i)=2*abs(RG(1,1)-1)+2*abs(RG(1,2)); %RGA number
end;

figure(5)
semilogx(omega,abs(RGA(1,:)),'b');
hold on;
semilogx(omega,abs(RGA(2,:)),'r');
hold off;
title('Diagonal (blue) and Off-diagonal RGA (red)')

figure(6)
semilogx(omega,abs(RGA(3,:)),'g');
title('RGA number')
    

