A=[-2 -2 0 0; 1 0 0 0;0 0 -2 -2; 0 0 1 0];
B=[1 0 0 0;0 0 1 0]';
C=[-0.01 -10 5 0; 0 20 0.01 20];
Plant=ss(A,B,C,zeros(2,2));

%===Decentralized controller design (off-diagonal pairing)
wc=2e-1;%Desired cutoff frequency, you can vary this
t=(0:1000)*0.001*14/wc;
u=cos(0*t);

num1=wc*[1 2 2];
den1=[5 0 0];
num2=num1;
den2=[1/wc 20 0];

K=tf({0 num1;num2 0},{1 den1;den2 1});
L = Plant*K;
Unit=eye(2);
T=feedback(L,Unit);
S=Unit-T;

figure(11)
bodemag(T,'b');
hold on;
bodemag(S,'r');
hold off;
title('Sensitivity Functions')

figure(12)
step(T,10/wc);
title('Close Loop Plant Step Responses')

figure(13)
lsim(T,[1*u' 1*u'],t);
title('Close Loop Plant Step Responses')


%=====Sinusoidal reference response
wr=1000; %reference frequency
t=(0:1000)*0.001*20/wr;
u=sin(wr*t);
figure(14)
lsim(T,[1*u' 1*u'],t);